Subject: Re: bug#70815: [PATCH] ; Enahnce python-tests.el to adapt different python interpreters

From: kobarity <[email-masked]>
Date: Sun, 02 Jun 2024 22:20:47 +0900

Mattias Engdegård wrote:
> 29 maj 2024 kl. 16.56 skrev kobarity <[email-masked]>:
> 
> > What I want to do now is not to
> > fix the "bug", but to accept the current situation and express it as
> > the ERTs.  Otherwise, even if we change the order of the interpreters,
> > it will fail when some Mac user sets EMACS_PYTHON_INTERPRETER to
> > "python" and runs ERTs for example.
> 
> That's very generous of you but watch out so that you don't waste time on busywork that isn't strictly necessary.
> 
> I did adjust the order of the interpreters in 9c7de10079, by the way; that took care of my own itches for this bug.
> 
> Do whatever you feel is necessary but again, your own time is precious.

Thanks, but as I mentioned before, this is something I thought we
would need sooner or later, even before the bug was found.

The attached patch is my proposal.  I added PRED argument to
`python-tests-get-shell-interpreter' to allow conditions to be
specified when selecting an interpreter.  For now, I only provide a
predicate that the major version of the interpreter is 3, but I think
it would be easy to add.

It would be helpful if you could try each of the following on Mac.

1. Set EMACS_PYTHON_INTERPRETER environment variable to "python" and
   run ERTs.  The expectation is that the 7 ERTs that previously
   resulted in errors will be skipped.
2. Revert 9c7de10079 and run ERTs.  The expectation is that the 7 ERTs
   that previously failed will succeed.

BTW, Apple seems to have removed Python 2 in 2022 MacOS 12.3.  Is your
Python 2 installed with brew or something else? Or is it an old Apple
one?